diff -Nar -u5 trunk.orig/ac.c trunk/ac.c
--- trunk.orig/ac.c	2013-07-31 19:43:11.000000000 +0200
+++ trunk/ac.c	2013-07-31 19:47:15.128232142 +0200
@@ -341,16 +341,33 @@
 
 /* guess what this does... */
 
 void give_usage(void)
 {
-  (void)printf("\
-                Usage: %s [-dhpVy] [-f <file>] [people] ...\n\
-                [--daily-totals] [--individual-totals] [--file <file>]\n\
-                [--complain] [--reboots] [--supplants] [--timewarps] [--print-year]\n\
-                [--compatibility] [--print-zeros] [--debug] [--tw-leniency <value>]\n\
-                [--tw-suspicious <value>] [--version] [--help]\n", program_name);
+  (void)printf(
+  "\n"
+  "Usage: %s [OPTION] ...\n"
+  "\n"
+  "OPTIONS:\n"
+  "  -d, --daily-totals        Print totals for each day\n"
+  "  -p, --individual-totals   Print time totals for each user\n"
+  "  -f, --file <file>         Read from <file>\n"
+  "  --complain                Print errors for whatever problem\n"
+  "  --reboots                 Count the time between login and reboot\n"
+  "  --supplants               Count the time between logins on the terminal\n"
+  "  --timewarps               Count the time between login and time warp\n"
+  "  --compatibility           Shortcut for --reboots --supplants --timewarps\n"
+  "  -a, --all-days            Do not skip days without login activity\n"
+  "  --tw-leniency <value>     Set the time warp leniency <value> in seconds\n"
+  "  --tw-suspicious <value>   Set the time warp suspicious <value> in seconds\n"
+  "  --print-year              Print year when displaying dates\n"
+  "  --print-zeros             Don't suppress zeros in category totals\n"
+  "  --debug                   Print verbose internal information\n"
+  "  -V, --version             Show version and exit\n"
+  "  -h, --help                Show help and exit\n"
+  , program_name);
+
   print_wtmp_file_location();
 }
 
 /* Since the routines in ac & last are so similar, just include them
    from another file. */
diff -Nar -u5 trunk.orig/dump-acct.c trunk/dump-acct.c
--- trunk.orig/dump-acct.c	2013-07-31 19:43:11.000000000 +0200
+++ trunk/dump-acct.c	2013-07-31 19:47:15.128232142 +0200
@@ -48,12 +48,13 @@
 {
   printf ("Usage: %s [-hrR] [-n <recs>] <files>\n\
           [--num <recs>] [--raw] [--reverse] [--help]\n",
           program_name);
 #ifdef LINUX_MULTIFORMAT
-  printf ("       [--format <version>] [--byteswap]\n");
+  printf ("          [--format <version>] [--byteswap]\n");
 #endif
+  printf ("          [--ahz <freq>]\n");
   print_acct_file_location ();
 }
 
 int main(int argc, char *argv[])
 {
diff -Nar -u5 trunk.orig/dump-acct.8 trunk/dump-acct.8
--- trunk.orig/dump-acct.8	1970-01-01 01:00:00.000000000 +0100
+++ trunk/dump-acct.8	2013-07-31 19:47:31.444750916 +0200
@@ -0,0 +1,53 @@
+.\" Copyright (C) 2009 Red Hat, Inc. All Rights Reserved.
+.\" Written by Ivana Hutarova Varekova <varekova@redhat.com>
+.TH DUMP_ACCT 8 "2009 December 2" "Linux accounting system"
+
+.SH NAME
+dump\-acct \- print an acct/pacct file in human-readable format
+
+.SH SYNOPSIS
+.B dump-acct
+[\fB\-r\fR|\fB\-\-reverse\fR]
+[\fB\-R\fR|\fB\-\-raw\fR]
+[\fB\-n\fR|\fB\-\-num\fR\ \fIrecs\fR]
+[\fB\-\-byte\-swap\fR]
+[\fB\-\-format\fR]
+[\fB\-\-ahz\fR\ \fIfreq\fR]
+[\fB\-h\fR|\fB\-\-help\fR]
+[\fIfiles\fR]
+
+.SH DESCRIPTION
+The dump-acct command transforms the output \fBfile\fR from the
+accton format to the human-readable format: one record per line.
+Each record consists of severald fields which are separated by
+character "|" (the meaning of concreate field depends on the
+version of kernel package - with which the accton file was created).
+
+.SH OPTIONS
+The following options are supported:
+.TP
+.B -r, --reverse
+Print the output in reverse order.
+.TP
+.B -R, --raw
+The records will be printed without any parsing.
+.TP
+.B -n, --num NUMRECS
+Display only the first NUMRECS number of records.
+.TP
+.B --byteswap
+Swap the bytes (relative to your system's native byte order) in --raw output.
+.TP
+.B --format
+Set output format with --raw option.
+.TP
+.B --ahz FREQ
+Set the AHZ (platform dependent frequency in Hertz) to FREQ.
+.TP
+.B -h, --help
+Print a help message and the default location of the process accounting file
+and exit.
+
+.SH SEE ALSO
+accton (8), lastcomm (1)
+
diff -Nar -u5 trunk.orig/lastcomm.c trunk/lastcomm.c
--- trunk.orig/lastcomm.c	2013-07-31 19:43:11.000000000 +0200
+++ trunk/lastcomm.c	2013-07-31 19:47:15.128232142 +0200
@@ -302,11 +302,11 @@
                "       [--user <name>] [--tty <name>] [--command <name>] [--debug]\n"
                "       "
 #ifdef HAVE_PAGING
                "[--show-paging] "
 #endif
-               "[--version] [--help]\n", program_name);
+               "[--ahz <freq>] [--version] [--help]\n", program_name);
   print_acct_file_location ();
 }
 
 /* parse the entries in an acct file */
 
diff -Nar -u5 trunk.orig/lastcomm.1 trunk/lastcomm.1
--- trunk.orig/lastcomm.1	2013-07-31 19:43:11.000000000 +0200
+++ trunk/lastcomm.1	2013-07-31 19:47:15.129232112 +0200
@@ -16,58 +16,11 @@
 .br
 [
 .I terminal-name ...
 ]
 .br
-[ 
-.B \-\-strict-match
-]
-.br
-[
-.B \-\-forwards
-]
-.br
-[
-.BI \-f " filename"
-|
-.BI \-\-file " filename"
-]
-[
-.BI \-\-ahz " hz"
-]
-.br
-[
-.B \-\-user
-.I name
-]
-[
-.B \-\-command
-.I name
-]
-[
-.B \-\-tty
-.I name
-]
-.br
-[
-.B \p
-|
-.B \-\-show_paging
-]
-[
-.B \-\-debug
-]
-[
-.B \-V
-|
-.B \-\-version 
-]
-[
-.B \-h
-|
-.B \-\-help 
-]
+[ OPTION ... ]
 .ad b
 .hy 1
 .SH DESCRIPTION
 .LP
 .B lastcomm
@@ -113,14 +66,17 @@
    + the name of the user who ran the process
    + time the process exited
 .SH OPTIONS
 .PD 0
 .TP
-.B \-\-strict-match
+.B \-\-strict\-match
 Print only entries that match *all* of the arguments on the command
 line.
 .TP
+.B \-\-print\-controls 
+Print control characters.
+.TP
 .BI \-\-user " name"
 List records for user with
 .I name.
 This is useful if you're trying
 to match a username that happens to be the same as a command (e.g.,
diff -Nar -u5 trunk.orig/sa.8 trunk/sa.8
--- trunk.orig/sa.8	2013-07-31 19:43:11.000000000 +0200
+++ trunk/sa.8	2013-07-31 19:47:15.129232112 +0200
@@ -41,11 +41,11 @@
 ]
 .br
 [
 .B \-i
 |
-.B \-\-dont-read-summary-file
+.B \-\-dont-read-summary-files
 ]
 .br
 [
 .B \-j
 |
@@ -280,11 +280,11 @@
 .TP
 .B \-f, \-\-not-interactive
 When using the `\-\-threshold' option, assume that all answers to
 interactive queries will be affirmative.
 .TP
-.B \-i, \-\-dont-read-summary-file
+.B \-i, \-\-dont-read-summary-files
 Don't read the information in the system's default
 .I savacct
 file.
 .TP
 .B \-j, \-\-print-seconds
@@ -384,11 +384,11 @@
 .I filename
 rather than the system's default
 .I SAVACCT
 file.
 .TP
-.BI \-\-other-file " filename"
+.BI \-\-other-acct-file " filename"
 Read from the file 
 .I filename 
 instead of the system's default
 .I ACCT
 file.