--- /home/rffontenelle/Downloads/right-to-read.pt-br.po	2016-12-02 09:57:50.433881947 -0200
+++ philosophy/right-to-read.pt-br.po	2016-12-03 17:50:01.560055458 -0200
@@ -11,7 +11,7 @@
 "Project-Id-Version: right-to-read.html\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2016-11-06 21:25+0000\n"
-"PO-Revision-Date: 2016-11-14 22:41-0200\n"
+"PO-Revision-Date: 2016-12-03 17:49-0200\n"
 "Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
@@ -96,8 +96,8 @@
 "E não havia muita chance de que a SPA &mdash; <em>Software Protection "
 "Authority</em> &mdash; não o descobrisse. Na aula de software, Dan aprendera "
 "que cada livro tinha embutido um monitor de direitos autorais, que informava "
-"quando e onde ele era lido, e por quem, para a Central de Licenciamento. ("
-"Eles usavam essa informação para pegar piratas de leitura, mas também para "
+"quando e onde ele era lido, e por quem, para a Central de Licenciamento. "
+"(Eles usavam essa informação para pegar piratas de leitura, mas também para "
 "vender perfis de interesses pessoais a empresas.) Na próxima vez em que seu "
 "computador estivesse conectado à rede, a Central de Licenciamento iria "
 "saber. Ele, como dono do computador, receberia a mais dura punição, por não "
@@ -135,7 +135,7 @@
 "journal publishers had begun charging fees for access.  By 2047, libraries "
 "offering free public access to scholarly literature were a dim memory."
 msgstr ""
-"Mais tarde, Dan aprenderia que havia um tempo em que qualquer pessoa poderia "
+"Mais tarde, Dan aprenderia que houve um tempo em que qualquer pessoa poderia "
 "ir à biblioteca e ler artigos de periódicos, e até mesmo livros, sem ter que "
 "pagar. Havia estudiosos independentes que liam milhares de páginas sem "
 "precisar obter permissões governamentais para uso de biblioteca. Mas, nos "
@@ -170,7 +170,7 @@
 "use in actual practice.  This meant they were illegal; the debuggers' "
 "developers were sent to prison."
 msgstr ""
-"Dan ainda iria aprender que havia um tempo em que qualquer pessoa podia ter "
+"Dan ainda iria aprender que houve um tempo em que qualquer pessoa podia ter "
 "ferramentas depuradoras. Existiam até mesmo ferramentas depuradoras "
 "gratuitas disponíveis em CD, ou que podiam ser baixadas pela rede. Mas "
 "usuários comuns começaram a usá-las para passar por cima dos monitores de "
@@ -220,9 +220,9 @@
 "that could mean she loved him too."
 msgstr ""
 "Dan concluiu que simplesmente não podia emprestar seu computador para Lissa. "
-"Mas ele não podia se recusar a ajudá-la, porque a amava. Cada chance de "
-"falar com ela o deixava em êxtase. E já que ela o havia escolhido para ajudá-"
-"la, isso poderia significar que ela o amava também."
+"Mas ele não podia se recusar a ajudá-la porque a amava. Cada chance de falar "
+"com ela o deixava em êxtase. E já que ela o havia escolhido para ajudá-la, "
+"isso poderia significar que ela o amava também."
 
 #. type: Content of: <div><div><p>
 msgid ""
@@ -325,12 +325,12 @@
 "project it forwards into something more visibly oppressive. See <a href=\"/"
 "philosophy/words-to-avoid.html#Piracy\">&ldquo;Piracy&rdquo;</a>."
 msgstr ""
-"Essa história é, supostamente, um artigo histórico que será escrito no "
-"futuro por alguém, descrevendo a juventude de Dan Halbert sob uma sociedade "
-"repressiva moldada pelas forças injustas que usam \"pirata\" como "
-"propaganda. Então, ele usa a terminologia daquela sociedade. Eu tentei "
-"projetá-la em algo visivelmente mais opressivo. Veja <a href=\"/philosophy"
-"/words-to-avoid.html#Piracy\">&ldquo;Pirataria&rdquo;</a>."
+"Essa estória é, supostamente, um artigo histórico que será escrito no futuro "
+"por alguém, descrevendo a juventude de Dan Halbert sob uma sociedade "
+"repressiva moldada pelas forças injustas que usam “pirata” como propaganda. "
+"Então, ele usa a terminologia daquela sociedade. Eu tentei projetá-la em "
+"algo visivelmente mais opressivo. Veja <a href=\"/philosophy/words-to-avoid."
+"html#Piracy\">“Pirataria”</a>."
 
 #. type: Content of: <div><div><ul><li><div><p>
 msgid ""
@@ -341,10 +341,10 @@
 "Design</a> campaign.  We ask for your support."
 msgstr ""
 "Restrições impostas por computador ao empréstimo e leitura de livros (e "
-"outros tipos de obras publicadas) são conhecidas como DRM, abreviação para \""
-"Gestão Digital de Restrições\". Para eliminar DRM, a Free Software "
-"Foundation estabeleceu a campanha <a href=\"http://DefectiveByDesign.org\">"
-"Defective by Design</a>. Nós solicitamos seu suporte."
+"outros tipos de obras publicadas) são conhecidas como DRM, abreviação para "
+"“Gestão Digital de Restrições”. Para eliminar DRM, a Free Software "
+"Foundation estabeleceu a campanha <a href=\"http://DefectiveByDesign.org"
+"\">Defective by Design</a>. Nós pedimos por seu apoio."
 
 #. type: Content of: <div><div><ul><li><div><p>
 msgid ""
@@ -375,12 +375,12 @@
 "in a form not quite as strong."
 msgstr ""
 "A batalha pelo direito à leitura já está sendo travada. Embora ainda possa "
-"levar 50 anos para nossa forma corrente de vida desaparecer na obscuridade, "
-"a maior parte das leis e práticas repressivas descritas acima já foram "
+"levar 50 anos para nossa forma atual de vida desaparecer na obscuridade, a "
+"maior parte das leis e práticas repressivas descritas acima já foram "
 "propostas; algumas já foram aprovadas como leis nos Estados Unidos e em "
-"outros lugares. Nos Estados Unidos, o <em>Digital Millennium Copyright "
-"Act</em> (DMCA) de 1998 forneceu suporte governamental explícita às "
-"restrições impostas por computador conhecidas como DRM, tornando um crime a "
+"outros lugares. Nos Estados Unidos, o <em>Digital Millennium Copyright Act</"
+"em> (DMCA), de 1998, forneceu apoio governamental explícito às restrições "
+"impostas por computador conhecidas como DRM, tornando um crime a "
 "distribuição de programas que possa quebrar DRM. A União Europeia impôs "
 "restrições similares em uma diretiva de copyright em 2001, em uma forma não "
 "muito forte."
@@ -395,14 +395,14 @@
 "criminalizing programs that break DRM is one of many unjust policies that "
 "these treaties impose across a wide range of fields."
 msgstr ""
-"As campanhas dos Estados Unidos para impor tais regras no resto do mundo por "
-"meio dos tão chamados tratados de \"comércio livre\". <a href=\""
-"https://stallman.org/business-supremacy-treaties.html\">Tratados de "
-"supremacia dos negócios</a> (em inglês, business-supremacy treaties) é um "
-"termo mais adequado para eles, já que são projetados para dar domínio a "
-"negócios sobre estados nominalmente democráticos. A política do DMCA de "
-"criminalizar programas que quebram DRM é uma das muitas políticas injustas "
-"que esses tratados impõem por uma ampla gama de campos."
+"Os Estados Unidos fazem campanhas para impor tais regras no resto do mundo "
+"por meio dos tão chamados tratados de “comércio livre”. <a href=\"https://"
+"stallman.org/business-supremacy-treaties.html\">Tratados de supremacia dos "
+"negócios</a> (em inglês, business-supremacy treaties) é um termo mais "
+"adequado para eles, já que são projetados para dar domínio a negócios sobre "
+"estados nominalmente democráticos. A política do DMCA de criminalizar "
+"programas que quebram DRM é uma das muitas políticas injustas que esses "
+"tratados impõem por uma ampla gama de campos."
 
 #. type: Content of: <div><div><ul><li><div><p>
 msgid ""
@@ -455,12 +455,12 @@
 "overcome.  Of course, Windows 10 is no better"
 msgstr ""
 "Com o Windows Vista, a Microsoft admitiu ter incorporado um <i>backdoor</i>: "
-"a Microsoft pode usá-la para forçadamente instalar \"atualizações\" de "
-"softwares, mesmo se usuários considerem estas serem um retrocesso (downgrade)"
-". Ela pode também ordenar que todas as máquinas funcionando com o Vista "
-"recusem executar um certo driver de dispositivo. O propósito central da "
-"repressão do Vista sobre usuários era impor DRM, de forma que usuários não "
-"poderiam evitar. É claro, Windows 10 não é melhor."
+"a Microsoft pode usá-la para forçadamente instalar “atualizações” de "
+"softwares, mesmo se usuários considerem estas serem um retrocesso "
+"(downgrade). Ela pode também ordenar que todas as máquinas funcionando com o "
+"Vista recusem executar um certo driver de dispositivo. O propósito central "
+"da repressão do Vista sobre usuários era impor DRM, de forma que usuários "
+"não poderiam evitar. É claro, Windows 10 não é melhor."
 
 #. type: Content of: <div><div><ul><li><div><p>
 msgid ""
@@ -469,9 +469,8 @@
 "personal computers, and not let you have them."
 msgstr ""
 "Uma das ideias na estória não foi proposta na realidade até 2002. É a ideia "
-"de que o FBI e a Microsoft teriam a senha de administrador "
-"(<cite>root</cite>) dos computadores pessoais e não permitiriam que você a "
-"tivesse."
+"de que o FBI e a Microsoft teriam a senha de administrador (<cite>root</"
+"cite>) dos computadores pessoais e não permitiriam que você a tivesse."
 
 #. type: Content of: <div><div><ul><li><div><p>
 msgid ""
@@ -479,10 +478,9 @@
 "trusted computing&rdquo; and &ldquo;Palladium&rdquo;, but as ultimately put "
 "into use, it is called &ldquo;secure boot&rdquo;."
 msgstr ""
-"Os proponentes deste esquema deram às versões anteriores nomes como "
-"\"trusted computing\" (computação confiável) e \"Palladium\" (paládio), mas, "
-"no final das contas, passou a ser chamado de \"secure boot\" (inicialização "
-"segura)."
+"Os proponentes deste esquema deram às versões anteriores nomes como “trusted "
+"computing” (computação confiável) e “Palladium” (paládio), mas, no final das "
+"contas, passou a ser chamado de “secure boot” (inicialização segura)."
 
 #. type: Content of: <div><div><ul><li><div><p>
 msgid ""
@@ -501,8 +499,8 @@
 "computador. Isso possibilita que a Microsoft (e potencialmente qualquer "
 "<cite>web site</cite> que coopere com ela) tenha o controle final sobre o "
 "que o usuário possa fazer em cada computador. A Microsoft provavelmente usa "
-"esse controle em prol do FBI, quando requisitado: ela já <a href=\""
-"/proprietary/malware-microsoft.html\">mostra os bugs de segurança da NSA no "
+"esse controle em prol do FBI, quando requisitado: ela já <a href=\"/"
+"proprietary/malware-microsoft.html\">mostra os bugs de segurança da NSA no "
 "Windows</a> para exploração."
 
 #. type: Content of: <div><div><ul><li><div><p>
@@ -517,8 +515,8 @@
 "especificar a chave de assinatura e decide qual software para assinar. Na "
 "prática, PCs projetados para Windows 10 carregam apenas a chave da "
 "Microsoft, e se o dono da máquina pode instalar qualquer outro sistema (tal "
-"como GNU/Linux) é algo sob controle da Microsoft. Nós chamamos de <em>"
-"restricted boot</em> (inicialização restrita)."
+"como GNU/Linux) é algo sob controle da Microsoft. Nós chamamos de "
+"<em>restricted boot</em> (inicialização restrita)."
 
 #. type: Content of: <div><div><ul><li><div><p>
 msgid ""
@@ -547,9 +545,9 @@
 "Argentina in 2001 made slightly veiled threats that people sharing software "
 "would be raped in prison."
 msgstr ""
-"A SPA, que na verdade se chamava <cite>\"Software Publishers Association\""
-"</cite>, foi substituída em seu papel policialesco pela <em>Business "
-"Software Alliance</em> (BSA). Hoje, a BSA não é uma força policial; mas, "
+"A SPA, que na verdade se chamava <cite>“Software Publishers Association”</"
+"cite>, foi substituída em seu papel policialesco pela <em>Business Software "
+"Alliance</em> (BSA). Hoje, a BSA não é uma força policial; mas, "
 "extraoficialmente, ela age como uma. Usando métodos reminiscentes da antiga "
 "União Soviética, ela incentiva as pessoas a denunciarem seus colegas de "
 "trabalho e amigos. Uma campanha de terror da BSA na Argentina em 2001 fazia "
@@ -609,7 +607,7 @@
 "The battle for the right to read is going against us so far.  The enemy is "
 "organized, and we are not."
 msgstr ""
-"A batalha pelo direito de ler está contra nós, O inimigo está organizado, e "
+"A batalha pelo direito de ler está contra nós. O inimigo está organizado, e "
 "nós não."
 
 #. type: Content of: <div><div><p>
@@ -624,11 +622,12 @@
 msgstr ""
 "Os e-books comerciais de hoje <a href=\"/philosophy/the-danger-of-ebooks.html"
 "\">abolem as liberdades tradicionais dos leitores</a>. O produto de leitura "
-"de e-books da Amazon, o qual eu chamo de \"Amazon Swindle\" porque ele é "
-"projetado para enganar os leitores retirando-lhes as liberdades traducionais "
-"de leitores de livros, é executado por um software com várias <a href=\"/"
-"proprietary/malware-kindle-swindle.html\">funcionalidades Owerllianas</a> "
-"demonstradas. Qualquer uma delas chamam por rejeitar o produto completamente:"
+"de e-books da Amazon, o qual eu chamo de “Amazon Swindle”<sup><a href="
+"\"#TransNote1\">1</a></sup> porque ele é projetado para enganar os leitores "
+"retirando-lhes as liberdades traducionais de leitores de livros, é executado "
+"por um software com várias <a href=\"/proprietary/malware-kindle-swindle.html"
+"\">funcionalidades Owerllianas</a> demonstradas. Qualquer uma delas chamam "
+"por rejeitar o produto completamente:"
 
 #. type: Content of: <div><div><ul><li><p>
 msgid ""
@@ -651,7 +650,7 @@
 "It has a back door with which Amazon can remotely erase any book.  In 2009, "
 "it erased thousands of copies of 1984, by George Orwell."
 msgstr ""
-"Ele possui \"backdoor\" por meio do qual a Amazon pode apagar remotamente "
+"Ele possui “backdoor” por meio do qual a Amazon pode apagar remotamente "
 "qualquer livro. Em 2009, ela apagou milhares de cópias de 1984, por George "
 "Orwell."
 
@@ -695,11 +694,11 @@
 "of ways to participate in our work</a>."
 msgstr ""
 "Se você deseja parar as más notícias e criar alguma notícia boa, nós "
-"precisamos organizar e lutar. Se inscreva na companha <a href=\""
-"http://defectivebydesign.org\">Defective by Design</a> da FSF para ajudar. "
-"Você pode <a href=\"http://www.fsf.org/associate\">se juntar à FSF</a> para "
-"apoiar nosso trabalho de forma mais geral. Há também uma <a href=\""
-"/help/help.html\">lista de formas para participar em nosso trabalho</a>."
+"precisamos organizar e lutar. Se inscreva na companha <a href=\"http://"
+"defectivebydesign.org\">Defective by Design</a> da FSF para ajudar. Você "
+"pode <a href=\"http://www.fsf.org/associate\">se juntar à FSF</a> para "
+"apoiar nosso trabalho de forma mais geral. Há também uma <a href=\"/help/"
+"help.html\">lista de formas para participar em nosso trabalho</a>."
 
 #. type: Content of: <div><h3>
 msgid "References"
@@ -712,10 +711,10 @@
 "a>] and the National Information Infrastructure: The Report of the Working "
 "Group on Intellectual Property [sic] Rights (1995)."
 msgstr ""
-"The administration's &ldquo;White Paper&rdquo;: Information Infrastructure "
-"Task Force, Intellectual Property [<a href=\"/philosophy/not-ipr.html\">sic</"
-"a>] and the National Information Infrastructure: The Report of the Working "
-"Group on Intellectual Property [sic] Rights (1995)."
+"The administration's “White Paper”: Information Infrastructure Task Force, "
+"Intellectual Property [<a href=\"/philosophy/not-ipr.html\">sic</a>] and the "
+"National Information Infrastructure: The Report of the Working Group on "
+"Intellectual Property [sic] Rights (1995)."
 
 #. type: Content of: <div><ul><li>
 msgid ""
@@ -788,7 +787,13 @@
 #. TRANSLATORS: Use space (SPC) as msgstr if you don't have notes.
 #. type: Content of: <div>
 msgid "*GNUN-SLOT: TRANSLATOR'S NOTES*"
-msgstr " "
+msgstr ""
+"<b>Nota do tradutor</b>:\n"
+"<ol>\n"
+"<li id=\"TransNote1\"><i>Swindle</i>, em “Amazon Swindle” é uma jogo de "
+"palavras com “Amazon Kindle” e “swindle”, sendo que esta última palavra em "
+"inglês poderia ser traduzida como fraude e trapaça ou ludibriar e enganar.</"
+"li></ol>"
 
 # type: Content of: <div><p>
 #. type: Content of: <div><div><p>
@@ -828,10 +833,10 @@
 msgstr ""
 "A equipe de traduções para o português brasileiro se esforça para oferecer "
 "traduções acuradas e de boa qualidade, mas não estamos isentos de erros. Por "
-"favor, envie seus comentários e sugestões em geral sobre as traduções para <"
-"a href=\"mailto:web-translators@gnu.org\">&lt;web-translators@gnu.org&gt;</a>"
-". </p><p>Consulte o <a href=\"/server/standards/README.translations.html\">"
-"Guia para as traduções</a> para mais informações sobre a coordenação e o "
+"favor, envie seus comentários e sugestões em geral sobre as traduções para "
+"<a href=\"mailto:web-translators@gnu.org\">&lt;web-translators@gnu.org&gt;</"
+"a>. </p><p>Consulte o <a href=\"/server/standards/README.translations.html"
+"\">Guia para as traduções</a> para mais informações sobre a coordenação e o "
 "envio de traduções das páginas desse site."
 
 #. type: Content of: <div><p>
@@ -848,18 +853,19 @@
 "creativecommons.org/licenses/by-nd/4.0/\">Creative Commons Attribution-"
 "NoDerivatives 4.0 International License</a>."
 msgstr ""
-"Esta página está licenciada sob uma licença <a rel=\"license\" href=\""
-"http://creativecommons.org/licenses/by-nd/4.0/deed.pt_BR\">Creative Commons "
+"Esta página está licenciada sob uma licença <a rel=\"license\" href=\"http://"
+"creativecommons.org/licenses/by-nd/4.0/deed.pt_BR\">Creative Commons "
 "Atribuição-SemDerivações 4.0 Internacional</a>."
 
 #. TRANSLATORS: Use space (SPC) as msgstr if you don't want credits.
 #. type: Content of: <div><div>
 msgid "*GNUN-SLOT: TRANSLATOR'S CREDITS*"
 msgstr ""
-"<b>Tradução:</b> João S. O. Bueno <a href=\"mailto:gwidion@mpc.com.br\"> "
-"&lt;gwidion@mpc.com.br&gt;</a>, Sérgio Vinícius <a href=\""
-"mailto:sergio@europanet.com.br\"> &lt;sergio@europanet.com.br&gt;</a>, "
-"Renato Candido, Hudson Flávio Meneses Lacerda."
+"<b>Tradução:</b> João S. O. Bueno <a href=\"mailto:gwidion@mpc.com.br\"> &lt;"
+"gwidion@mpc.com.br&gt;</a>; Sérgio Vinícius <a href=\"mailto:"
+"sergio@europanet.com.br\">&lt;sergio@europanet.com.br&gt;</a>; Renato "
+"Candido, 2013; Hudson Flávio Meneses Lacerda; Rafael Fontenelle <a href="
+"\"mailto:rafaelff@gnome.org\">&lt;rafaelff@gnome.org&gt;</a>, 2016."
 
 # type: Content of: <div><p>
 #.  timestamp start 
@@ -903,8 +909,8 @@
 #~ "can't overcome."
 #~ msgstr ""
 #~ "Com o Windows Vista, a Microsoft admitiu ter incorporado um <i>backdoor</"
-#~ "i>: a Microsoft pode usá-la para forçadamente instalar \"atualizações\" "
-#~ "de softwares, mesmo se usuários considerem estas serem um retrocesso "
+#~ "i>: a Microsoft pode usá-la para forçadamente instalar “atualizações” de "
+#~ "softwares, mesmo se usuários considerem estas serem um retrocesso "
 #~ "(downgrade). Ela pode também ordenar que todas as máquinas funcionando "
 #~ "com o Vista recusem executar um certo driver de dispositivo. O propósito "
 #~ "central da repressão do Vista sobre usuários era impor DRM, de forma que "
@@ -941,10 +947,10 @@
 #~ msgstr ""
 #~ "Os ebooks comerciais de hoje <a href=\"/philosophy/the-danger-of-ebooks."
 #~ "html\">abolem as liberdades tradicionais dos leitores</a>. O produto de "
-#~ "leitura de e-books da Amazon, o qual eu chamo de \"Amazon Swindle\" "
-#~ "porque ele é projetado para enganar os leitores retirando-lhes as "
-#~ "liberdades traducionais de leitores de livros, é executado por um "
-#~ "software com várias <a href=\"/proprietary/malware-kindle-swindle.html"
+#~ "leitura de e-books da Amazon, o qual eu chamo de “Amazon Swindle” porque "
+#~ "ele é projetado para enganar os leitores retirando-lhes as liberdades "
+#~ "traducionais de leitores de livros, é executado por um software com "
+#~ "várias <a href=\"/proprietary/malware-kindle-swindle.html"
 #~ "\">funcionalidades Owerllianas</a> demonstradas. Qualquer uma delas "
 #~ "chamam por rejeitar o produto completamente:"
 
@@ -999,8 +1005,8 @@
 #~ "são configurados para dar a operadores remotos o controle sobre as "
 #~ "pessoas que efetivamente usam o sistema. O SSSCA posteriormente teve seu "
 #~ "nome trocado para o impronunciável CBDTPA, que foi apelidado de "
-#~ "\"<em>Consume But Don't Try Programming Act</em>\" (ato de \"consuma mas "
-#~ "não tente programar\")."
+#~ "“<em>Consume But Don't Try Programming Act</em>” (ato de “consuma mas não "
+#~ "tente programar”)."
 
 #~ msgid ""
 #~ "The Republicans took control of the US senate shortly thereafter.  They "
@@ -1046,7 +1052,7 @@
 #~ "to lend it to anyone else</a>, which the publisher can revoke at will."
 #~ msgstr ""
 #~ "Um sítio de <a href=\"http://www.nature.com/nature_education/"
-#~ "interactive_textbooks\">\"livros-texto de biologia\"</a> que você pode só "
+#~ "interactive_textbooks\">“livros-texto de biologia”</a> que você pode só "
 #~ "pode acessar após assinar um <a href=\"http://www.nature.com/principles/"
 #~ "viewTermsOfUse\">contrato que proíbe o empréstimo para outras pessoas</"
 #~ "a>, o qual a editora pode revogar quando quiser;"